//  Macros-D3D.h

#pragma once

#define D3D_OVERLOADS
#include <d3dx.h>
#include "Exception.hpp"


#define SAFE_DELETE(x)  {if (x != NULL) {delete   x; x = NULL;}}
#define SAFE_DELETE_(x) {if (x != NULL) {delete[] x; x = NULL;}}

#define SAFE_RELEASE(object)    \
    if ((object) != NULL)       \
    {                           \
        (object)->Release();    \
        (object) = NULL;        \
    }

//  This avoids compiling the same code into every D3DTRY() call,
//  while keeping CException independent of the graphics library.

#define D3DTRY(x)   CheckD3DResult(x);

extern void CheckD3DResult(HRESULT hr);
