//  SceneryObject-D3D.hpp
//
//  This abstract class provides a consistent interface
//  for communicating with different scenery objects.

#pragma once

#include "Macros-D3D.h"


class CSceneryObject
{
public:

                    CSceneryObject(void)
                        { D3DXMatrixIdentity(&itsPosition); };

    virtual         ~CSceneryObject(void) {};

    //  Set itsPosition to a matrix consistent with the current SpaceType.
            void    SetPosition(D3DXMATRIX *aPosition)
                        { itsPosition = *aPosition; };

    //  A SceneryObject may have internal parts that need
    //  to be kept moving.  anElapsedTime tells it how many
    //  seconds have passed since the previous Update().
    virtual void    Update(double anElapsedTime) {};

    //  Render the SceneryObject.
    virtual void    Render(LPDIRECT3DDEVICE7 aDevice) = 0;

protected:
    D3DXMATRIX      itsPosition;
};

